import QtQuick 2.0
import Ubuntu.Components 0.1
import "qml"

/*!
    A bitcoin app for Ubuntu Touch.
*/

MainView {
    id: root
    objectName: "mainView"
    applicationName: "org.sambull.bitcoin-app"

    width: units.gu(50)
    height: units.gu(75)

    property int onebtc: 100000000

    PageStack {
        id: pagestack

        Component.onCompleted: push(tabs)

        Tabs {
            id: tabs
            Tab {
                id: accountsTab
                title: i18n.tr("Accounts")
                page: AccountsPage {
                    id: accountsPage
                }
            }
            Tab {
                id: sendTab
                title: i18n.tr("Send")
                iconSource: "call_icon.png"
                page: SendPage {
                    id: sendPage
                }
            }
            Tab {
                id: receiveTab
                title: i18n.tr("Receive")
                page: ReceivePage {
                    id: receivePage
                }
            }
            Tab {
                id: transactionsTab
                title: i18n.tr("Transactions")
                page: TransactionsPage {
                    id: transactionsPage
                }
            }
        }

        AddressbookPage { id: addressbookPage }
    }
}
