import QtQuick 2.0
import Ubuntu.Components 0.1
import Ubuntu.Components.ListItems 0.1 as ListItem

import "btcSupport.js" as Script

Page {
    Column {
        anchors.fill: parent    

        ListItem.Empty {
            Label {
                anchors {
                    top: parent.top
                    bottom: parent.bottom
                    right: totalLabel.left
                    topMargin: units.gu(1)
                    rightMargin: units.gu(1)
                }
                text: i18n.tr("Total:")
                fontSize: "large"
            }
            Label {
                id: totalLabel
                anchors {
                    top: parent.top
                    bottom: parent.bottom
                    right: parent.right
                    topMargin: units.gu(1)
                    rightMargin: units.gu(1)
                }
                text: Script.displayFullAmount(wallets.totalBalance.toString())
                fontSize: "large"
            }
        }
        ListItem.SingleValue {
            text: i18n.tr("Wallet")
            value: Script.displayRoundedAmount(wallets.wallet(0).balance)
            iconSource: Qt.resolvedUrl("../images/wallet.png")
            iconFrame: false
            onClicked: print("clicked")
            enabled: false
        }
        ListItem.Standard {
            text: i18n.tr("Add new account")
            iconSource: Qt.resolvedUrl("../images/addaccount.svg")
            iconFrame: false
            onClicked: print("Add new")
            enabled: false
            progression: true
        }
        ListItem.Empty {
            height: units.gu(1)
            showDivider: false
        }
        Button {
            anchors {
                left: parent.left;
                right: parent.right;
                margins: units.gu(1)
            }
            text: i18n.tr("Addressbook")
            onClicked: pagestack.push(addressbookPage)
        }
    }
}
