import QtQuick 2.0
import Ubuntu.Components 0.1
import Ubuntu.Components.ListItems 0.1 as ListItem

Page {
    Component.onCompleted: {
        var addressArray = wallets.wallet(0).getAddresses()
        for (var i=0; i < addressArray.length; i++)
            addresses.insert(0, {"address": addressArray[i]})
    }

    ListModel {
        id: addresses
        objectName: "addresses"
    }

    ListView {
        anchors.fill: parent
        model: addresses

        delegate: ListItem.Standard {
            text: addressbook.getAddressLabel(address)
            onClicked: print("Address")
            enabled: false
        }
    }

    tools: ToolbarItems {
        id: toolbarReceive

        ToolbarButton {
            action: Action {
                text: i18n.tr("New address")
                iconSource: Qt.resolvedUrl('image://theme/add')
                onTriggered: {
                    toolbarReceive.opened = false
                    addresses.insert(0, {"address":wallets.wallet(0).addAddress()})
                }
            }
        }
    }
}
