/** Displays amount in most appropriate denomination,
    but cut down to about 3 digits.
    Example: 1234 BTC, 12.3 mBTC, 0.78 μBTC */
function displayRoundedAmount(satoshies) {
    // Calculate denomination
    var denomination = "BTC"
    // 0 should remain "BTC"
    if (satoshies > 0) {
        if (satoshies < onebtc) {
            denomination = "mBTC"
            satoshies *= 1000
        }
        if (satoshies < onebtc) {
            denomination = "μBTC"
            satoshies *= 1000
        }
    }

    // Round to 3 digits
    var displayAmount
    if (satoshies <= 0)
        displayAmount = "0"
    else {
        var s = satoshies.toString()
        while (s.length <= 8)
            s = "0" + s

        displayAmount = s.slice(0, -8)
        if (s.slice(-8) != "00000000") {
            if (displayAmount.length == 2)
                displayAmount += "." + s.slice(-8, -7)
            else if (displayAmount.length == 1)
                displayAmount += "." + s.slice(-8, -6)
        }
    }

    return ("%L1 " + denomination).arg(displayAmount)
}

/** Displays amount in appropriate denomination,
    but with all decimal places. */
function displayFullAmount(satoshies) {
    // Calculate denomination
    var denomination = "BTC"
    // 0 should remain "BTC"
    if (satoshies > 0) {
        if (satoshies < onebtc) {
            denomination = "mBTC"
            satoshies *= 1000
        }
        if (satoshies < onebtc) {
            denomination = "μBTC"
            satoshies *= 1000
        }
    }

    var displayAmount
    var s = satoshies.toString()
    while (s.length <= 8)
        s = "0" + s

    // Strip trailing 0
    var fraction = s.slice(-8)
    while (fraction.slice(-1) == "0")
        fraction = fraction.slice(0, -1)

    if (fraction > 0)
        displayAmount = s.slice(0, -8) + "." + fraction.toString()
    else
        displayAmount = s.slice(0, -8)

    return ("%L1 " + denomination).arg(displayAmount)
}

/* Displays amount with all decimal places in BTC. */
function displayFullBitcoin(satoshiesStr) {
    while (satoshiesStr.length <= 8)
        satoshiesStr = "0" + satoshiesStr

    // Strip trailing 0
    var fraction = satoshiesStr.slice(-8)
    while (fraction.slice(-1) == "0")
        fraction = fraction.slice(0, -1)

    var displayAmount
    if (fraction > 0)
        displayAmount = satoshiesStr.slice(0, -8) + "." + fraction
    else
        displayAmount = satoshiesStr.slice(0, -8)

    return "%L1 BTC".arg(displayAmount)
}

function showTime(time) {
    var today = new Date()
    today.setHours(0)
    today.setMinutes(0)
    today.setSeconds(0)
    today.setMilliseconds(0)

    var lastWeek = new Date(today).setDate(today.getDate() - 6)

    var thisYear = new Date(today)
    thisYear.setMonth(0)
    thisYear.setDate(0)

    var suffixes = new Array("th", "st", "nd", "rd", "th", "th", "th", "th",
                             "th", "th", "th", "th", "th", "th", "th", "th",
                             "th", "th", "th", "th", "th", "st", "nd", "rd",
                             "th", "th", "th", "th", "th", "th", "th", "st")
    var suffix = suffixes[time.getDate()]

    if (time >= today)
        return Qt.formatTime(time, "hh:mm")
    else if (time >= lastWeek)
        return Qt.formatDate(time, "ddd")
    else if (time >= thisYear) {
        var return_string = Qt.formatDate(time, "d MMM").split(" ")
        return return_string[0].concat(suffix, " ", return_string[1])
    } else
        return Qt.formatDate(time, "dd/MM/yy")
}
