#   pragma once
#include "definitions.h"

class QAddressbook : public QObject
{
    Q_OBJECT

    std::string addressfile;
    std::unordered_map<std::string, std::string>* addressMap;
    QList<QString> addressbook;

    void updateAddressFile();

signals:
    void addressbookChanged();

public:
    QAddressbook(char* addressfile);

    Q_INVOKABLE QString getAddressLabel(QString address);
    Q_INVOKABLE QString getAddress(QString label);
    Q_INVOKABLE void setAddressLabel(QString address, QString label);
    Q_INVOKABLE bool hasAddressLabel(QString address);
    Q_INVOKABLE QList<QString> getAddressbook();
    Q_INVOKABLE bool canAddToAddressbook(QString label);
    Q_INVOKABLE void addToAddressbook(QString address);
    Q_INVOKABLE void removeFromAddressbook(QString address);

    Q_INVOKABLE QString displaySum(QList<int> values);
};
