#include "addressbook.h"
#include "wallets.h"

int main(int argc, char *argv[]) {

    // Code taken from: http://www.gamedev.net/community/forums/topic.asp?topic_id=459511
    std::string fullFileName = "";
    std::string path = "";
    pid_t pid = getpid();
    char buf[20] = {0};
    sprintf(buf,"%d",pid);
    std::string _link = "/proc/";
    _link.append( buf );
    _link.append( "/exe");
    char proc[512];
    int ch = readlink(_link.c_str(),proc,512);
    if (ch != -1) {
        proc[ch] = 0;
        path = proc;
        std::string::size_type t = path.find_last_of("/");
        path = path.substr(0,t);
    }
    fullFileName = path + std::string("/");
    chdir(fullFileName.c_str());

    std::string env_home(getenv("HOME"));
    std::string share_location("/.local/share/");
    std::string app_name("org.sambull.bitcoin-app/");
    std::string blockfile_name("ubc.blockchain");
    std::string walletfile_name("ubc.wallet");
    std::string addressfile_name("ubc.addesses");

    std::string sharedir_string = env_home.append(share_location);
    QString sharedir_qstring(sharedir_string.c_str());

    std::string savedir_string = env_home.append(app_name);
    QString savedir_qstring(savedir_string.c_str());
    
    QDir savedir(savedir_qstring);

    if(!savedir.exists()){
        QDir outerDir(sharedir_qstring);
        QString mkdirstring(app_name.c_str());
        outerDir.mkdir(mkdirstring);

        std::ifstream src(blockfile_name.c_str(), std::ios::binary);
        std::ofstream dst(savedir_string.append(blockfile_name).c_str(),   std::ios::binary);

        dst << src.rdbuf();
    }

    std::string savedir_string1(env_home);
    char * blockchain_cstring = savedir_string1.append(blockfile_name).c_str();
    std::string savedir_string2(env_home);
    char * wallet_cstring = savedir_string2.append(walletfile_name).c_str();
    std::string savedir_string3(env_home);
    char * address_cstring = savedir_string3.append(addressfile_name).c_str();

    // Register all types available to qml
    qRegisterMetaType<QAbstractWallet*>("QAbstractWallet*");
    qmlRegisterUncreatableType<QLocalWallet>("org.sambull.bitcoin-app", 1, 0, "QLocalWallet", QString("why"));
    
    qRegisterMetaType<QLocalWallet*>("QLocalWallet*");
    qmlRegisterUncreatableType<QAbstractWallet>("org.sambull.bitcoin-app", 1, 0, "QAbstractWallet", QString("why"));
    
    qRegisterMetaType<QAddressbook*>("QAddressbook*");
    qmlRegisterUncreatableType<QAddressbook>("org.sambull.bitcoin-app", 1, 0, "QAddressbook", QString("why"));

    QGuiApplication app(argc, argv);
    QQuickView view;
    view.setResizeMode(QQuickView::SizeRootObjectToView);

    QQmlEngine engine;
    
    QAddressbook qaddressbook(address_cstring);
  
    view.rootContext()->setContextProperty("addressbook", &qaddressbook);
  
    QWallets qwallets(blockchain_cstring, wallet_cstring, fullFileName, &qaddressbook);
    
    view.rootContext()->setContextProperty("wallets", &qwallets);
    
    //Resolve the relative path to the absolute path (at runtime)
    const QString qmlFilePath = QString::fromLatin1("%1/%2").arg(QCoreApplication::applicationDirPath(), "Bitcoin.qml");
    view.setSource(QUrl::fromLocalFile(qmlFilePath));

    view.show();
    return app.exec();
}
