#include "abstractwallet.h"

class QLocalWallet : public QAbstractWallet
{
    Q_OBJECT

    JavaVM *jvm;       /* denotes a Java VM */
    JNIEnv *env;
    JavaVMInitArgs vm_args;
    JavaVMOption options;
    jmethodID ubcInit;
    jmethodID ubcGetAddress;
    jmethodID ubcAddAddress;
    jmethodID ubcGetAddressCount;
    jmethodID ubcGetValue;
    jmethodID ubcGetTransactionCount;
    jmethodID ubcGetTransactionStatus;
    jmethodID ubcGetTransactionValue;
    jmethodID ubcGetTransactionMyAddress;
    jmethodID ubcGetTransactionTheirAddress;
    jmethodID ubcGetTransactionTimestamp;
    jmethodID ubcGetTransactionConfidence;
    jmethodID ubcGetTransactionHash;
    jmethodID ubcSendCoins;
    jmethodID ubcCreateRequest;
    jmethodID ubcGetFee;
    jmethodID ubcGetTotal;
    jmethodID ubcSendTransaction;
    jmethodID ubcAddressIsValid;
    jobject obj;

signals:
    void balanceChanged();

public:
    QLocalWallet(char* blockfile, char* walletfile, std::string location);

    Q_PROPERTY(long balance READ balance NOTIFY balanceChanged);
    virtual long balance();
    virtual void emitBalanceChanged(){emit this->balanceChanged();}


    virtual Q_INVOKABLE int getAddressCount();
    virtual Q_INVOKABLE QString getAddress(int num);
    virtual Q_INVOKABLE QList<QString> getAddresses();
    virtual Q_INVOKABLE QString addAddress();

    virtual Q_INVOKABLE int             getTransactionCount();
    virtual Q_INVOKABLE int             getTransactionStatus(int tx);
    virtual Q_INVOKABLE int             getTransactionValue(int tx);
    virtual Q_INVOKABLE QString         getTransactionMyAddress(int tx);
    virtual Q_INVOKABLE QString         getTransactionTheirAddress(int tx);
    virtual Q_INVOKABLE QString         getTransactionTimestamp(int tx);
    virtual Q_INVOKABLE int             getTransactionConfidence(int tx);
    virtual Q_INVOKABLE QString         getTransactionHash(int tx);
    virtual Q_INVOKABLE QList<int>      getTransactionValues();
    virtual Q_INVOKABLE QList<QString>  getTransactionTheirAddresses();
    virtual Q_INVOKABLE QList<QString>  getTransactionMyAddresses();
    virtual Q_INVOKABLE QList<QString>  getTransactionTimestamps();
    virtual Q_INVOKABLE QList<int>      getTransactionConfidences();
    virtual Q_INVOKABLE QList<QString>  getTransactionHashes();


    virtual Q_INVOKABLE void sendCoins(int amount, QString address);
    virtual Q_INVOKABLE QString createRequest(QList<QString> amount, QList<QString> address);
    virtual Q_INVOKABLE int getFee();
    virtual Q_INVOKABLE int getTotal();
    virtual Q_INVOKABLE void sendTransaction();

    virtual Q_INVOKABLE bool addressIsValid(QString address);
};
