#include "wallets.h"

void pollBalance(QWallets* wallet){
    while (wallet->running == RUNNING){
        emit wallet->balanceChanged();
        for (int i = 0; i < wallet->numOfWallets(); i++)
        {
            wallet->wallet(i)->emitBalanceChanged();
        }
        for(int i = 0 ; i < 5; i++){
            if (!wallet->running) break;
            std::chrono::milliseconds dura( 1000 );
            std::this_thread::sleep_for( dura );
        }
    }
}

QWallets::QWallets(char* blockfile, char* walletfile, std::string location, QAddressbook* _addressbook)
{
    addressbook = _addressbook;
    running = STARTING;
    _wallets.push_back(new QLocalWallet(blockfile, walletfile, location));

    poller = new std::thread(pollBalance, this);
    running = RUNNING;
}

QWallets::~QWallets()
{
    running = STOPPED;
    poller->join();
}

Q_INVOKABLE bool QWallets::addressIsValid(QString address)
{
    if (addressbook->canAddToAddressbook(address))
        return _wallets[0]->addressIsValid(address);
    else
        return true;
}

Q_INVOKABLE long QWallets::totalBalance()
{
    long total = 0;
    for(int i = 0; i < _wallets.size(); i++)
    {
        total += _wallets[i]->balance();
    }
    return total;
}
