#include "definitions.h"
#include "localwallet.h"
#include "addressbook.h"

enum Status{STOPPED, RUNNING, STARTING};

class QWallets : public QObject
{
    Q_OBJECT

    std::thread* poller;

    QList<QAbstractWallet*> _wallets;

    QAddressbook* addressbook;
signals:
    void balanceChanged();

public:
    Q_PROPERTY(long totalBalance READ totalBalance NOTIFY balanceChanged);
    virtual long totalBalance();

    Status running;

    Q_INVOKABLE int numOfWallets(){ return _wallets.size(); }
    Q_INVOKABLE QAbstractWallet* wallet(int i){ return _wallets[i]; }
    QWallets(char* blockfile, char* walletfile, std::string location, QAddressbook* _addressbook);

    ~QWallets();


    Q_INVOKABLE bool addressIsValid(QString address);
};
